<?php

namespace App\Http\Controllers;
use App\Models\CoursesBanner;
use App\Repositories\ResponseRepository;
use Illuminate\Support\Facades\Log;
use Illuminate\Http\Request;

class CoursesBannerCOntroller extends Controller
{
    public function __construct(ResponseRepository $response) {
        $this->response = $response;
        $this->storeRules = 
        [
            'banner_name' => 'required',
            'courses_id' => 'required',
            'courses_name' => 'required',
        ];
    }

    public function indexCoursesBanner() {
        return $this->response->jsonResponse(false,"CoursesBanner Details Fetched Successfully", CoursesBanner::with('courseslist')->orderBy('id', 'desc')->get() , 300);
    }

    public function store(Request $request) {
        $validate = $this->response->validate($request->all(), $this->storeRules);
        if($validate === true) {
            $request['courses_slug'] = $this->response->generateSlug($request['courses_name']);
            return $this->response->jsonResponse(false, $this->response->message('Courses Banner', 'store'), CoursesBanner::create($request->all()), 301);
        } else {
            return $validate;
        }
    }

    public function show($id) {
        return $this->response->jsonResponse(false, $this->response->message('Banner', 'show'), $this->findBanner($id), 102);
    }

    public function updateCoursesBanner(Request $request) {
        $validate = $this->response->validate($request->all(), $this->storeRules);
        if($validate === true) {
            
            $request['courses_slug'] = $this->response->generateSlug($request['courses_name']);
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'update'), $this->findBanner($request->id)->update($request->all()), 303);
        } else {
            return $validate;
        }
    }

    public function destroy($id) {
        $size = $this->findBanner($id);
        if($size) {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'destroy'), $size->delete(), 104);
        }
        return $this->response->jsonResponse(true, 'Banner Not Exists', [], 105);
    }

    public function findBanner($id) {
        return CoursesBanner::find($id);
    }

    public function coursesBannerSwitch($id) {
        $size = $this->findBanner($id);
        if($size) {
            $value = $size->active_status === 1 ? 0 : 1;
            $msg = $value === 0 ? 'Deactivated': 'Activated';
            return $this->response->jsonResponse(false, 'Banner '.$msg.' SuccessFully', $size->update(['active_status' => $value]), 106);
        }
        return $this->response->jsonResponse(true, 'CoursesBanner Not Exists', [], 107);
    }

    public function imageUpdateCoursesBanner(Request $request) {
        $getBanner = $this->findBanner($request['banner_id']);
        if($request->hasFile('banner_image')) {
            $file = $request->file('banner_image');
            $name = $this->response->generateSlug($getBanner['banner_name']);
            $uploadUrl = $this->response->cloudinaryImage($request->file('banner_image'), 'Banner', $name);
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'image'), $getBanner->update(['banner_image' => $uploadUrl]), 108);
        } else {
            return $this->response->jsonResponse(true, 'Image Banner is too high', [], 109);
        }
    }

    public function searchCoursesBanner($search){
        if($search === "null") {
            return $this->response->jsonResponse(false, $this->response->message('Banner', 'search'), [], 110);
        }
        return $this->response->jsonResponse(false, $this->response->message('Banner', 'search'), CoursesBanner::where('banner_name', 'LIKE', '%'.$search.'%')->get(), 111);
    }

}
